#include "wsyslib.h"
#include <cassert>
#include <cstdio>
#include <vector>

int main() {
    int N, Q, H;
    assert(3 == scanf("%d %d %d", &N, &Q, &H));
    std::vector<int> A(N - 1), B(N - 1), D(N - 1), answers(Q);

    for (int i = 0; i < N - 1; ++i) {
        assert(3 == scanf("%d %d %d", &A[i], &B[i], &D[i]));
    }
    init(A, B, D, H);

    for (int i = 0; i < Q; ++i) {
        int u, v; long long C;
        assert(3 == scanf("%d %d %lld", &u, &v, &C));
        answers[i] = query(u, v, C);
    }
    fclose(stdin);

    for (int i = 0; i < Q; ++i) {
        printf("%d\n", answers[i]);
    }
    fclose(stdout);
    return 0;
}
